--CONFIG: shNameplates (REQUIRES RELOADING your UI for changes to take effect)

--**IMPORTANT** - BE very careful and ONLY change the values themselves, keep all commas/syntax entact or you will break the addon!

local addonname, ns = ...

local cfg = CreateFrame("Frame")

local mediapath = [=[Interface\AddOns\shNameplates\media\]=]

--> TEXTURE options (add your own textures here)
	cfg.bartex = 	mediapath.."bartexture"
	cfg.icontex = 	mediapath.."icontexture"
	
--> BEHAVIOR options
	cfg.autohide = false 	--> automatically hide nameplates when OUT OF COMBAT only
	cfg.autoshow = true		--> automatically show nameplates when IN COMBAT only
	cfg.overlap = 0			--> 0: nameplates overlap and 1: nameplates do NOT overlap
	cfg.threatbloat = 0		--> 0: keeps nameplates consistant size and 1: makes nameplates larger depending on threat percentage
	cfg.tankmode = false 	--> true: will show GREEN overlay if you HAVE aggro and false: will show RED overlay if you HAVE aggro
	cfg.namecolor = true	--> true: will show unit names in color of their hostility/pvp or false: will show static color given below
	
--> COLOR options (any RGB percent color of your choosing)
	cfg.colors = {
		hostile = 		{ 0.70, 0.34, 0.34 },	--> Default: red 
		friendlynpc =	{ 0.33, 0.59, 0.33 },	--> Default: green 
		friendly = 		{ 0.31, 0.45, 0.63 },	--> Default: blue 
		neutral = 		{ 0.65, 0.63, 0.35 }, 	--> Default: yellow 
		
	--> tankmode color options (ONLY APPLY if you have tankmode SET to TRUE)
		aggroglow = 	{ 0.15, 0.69, 0.0  }, 	--> If you have aggro, the glow around the nameplate (ONLY WORKS if TANKMODE = true)
		aggro =			{ 0.25, 0.64, 0.32 }, 	--> If you have aggro, the status bar color itself (ONLY WORKS if TANKMODE = true)
	}	
	
--> BACKDROP table for the statusbars (taken from Caelian and edited)
	cfg.backdrop = {
		bgFile   =  mediapath.."bg",
		edgeFile = 	mediapath.."glowtexture", 
		edgeSize = 	3,
		insets   = 	{ left = 1, right = 1, top = 1, bottom = 1 }, 
	}
	
--> RAIDICON
	cfg.raidicon = {
		textures = 	"Interface\\TargetingFrame\\UI-RaidTargetingIcons", 
		size = 20,					--> square dimension (in pixels)
		anchor = "BOTTOM",			--> anchor point of the raidicon to the health bar
		anchor2 = "TOP",			--> anchor point of the healthbar to the raidiconssss
		xoffset = 0,				--> x-offset of the anchor
		yoffset = 9,				--> y-offset of the anchor
	}
	
--> SPELLICON
	cfg.spellicon = {
		size = 		20,				--> square dimension (in pixels)
		anchor = 	"LEFT",			--> anchor point of the spell icon to cast bar
		anchor2 = 	"RIGHT",		--> anchor point of the cast bar to spell icon
		xoffset = 	3,				--> x-offset of the anchor
		yoffset =	0,				--> y-offset of the anchor
	}

--> HEALTHBAR 	
	cfg.healthbar = {
		showhpvalue = 	true, 		--> show hp value text in healthbar if not at 100% health (always shows hp value for bosses)
		hpallthetime = 	false,		--> shows the hp value of the mob at all times
		width = 		130, 		--> healthbar bar width
		height = 		14,			--> healthbar bar height
		yoffset = 		8, 			--> y-offset of the nameplate itself from the default blizzard nameplate
	}
	
--> CASTBAR
	cfg.castbar = {
		width =		130,						--> castbar bar width
		height = 	10,							--> castbar bar height
		anchor = 	"TOPRIGHT", 				--> anchor point of the castbar to the health bar
		anchor2 =	"BOTTOMRIGHT", 				--> anchor point of the healthbar to the cast bar
		xoffset =	0, 							--> x-offset of the anchor 
		yoffset =	-4, 						--> y-offset of the anchor
	}
		
--> CASTTIME
	cfg.casttime = {
		--> Cast time options
		font = 		mediapath.."verdanab.ttf", 		--> cast time font
		fontSize = 	6.5, 							--> cast time font size
		fontFlag =  "THINOUTLINE",				--> cast time font flag
		alpha = 	0.85,						--> alpha of cast time	
		anchor = 	"CENTER", 					--> anchor point of cast time to the castbar
		anchor2 =	"LEFT", 					--> anchor point of castbar to the cast time
		xoffset =	0, 							--> x-offset of the anchor 
		yoffset =	0, 							--> y-offset of the anchor
	}	
	
--> SPELL NAME text attributes
	cfg.spellname = {
		font =		mediapath.."verdanab.ttf",	--> spell name font
		fontSize =	6,							--> spell name font size
		fontFlag = 	"THINOUTLINE",				--> spell name font flag
		color = 	{ 1, 1, 1 },				--> spell name color
		anchor = 	"CENTER", 					--> anchor point of the spell name text to the cast bar
		anchor2 =	"CENTER",					--> anchor point of the cast bar to the spell name text
		xoffset =	0, 							--> x-offset of the anchor 
		yoffset =	0.5, 						--> y-offset of the anchor
	}
	
--> NAME text attributes
	cfg.name = {
		font = 		mediapath.."verdanab.ttf", 
		fontSize = 	6.5,	
		fontFlag =  "THINOUTLINE",
		color = 	{ 0.9, 0.8, 0.7 },	
		alpha = 	1,
		uppercase = true,			--> change to false to format in all lower cases
		anchor = 	"BOTTOM", 		--> anchor point of the name text to the health bar
		anchor2 =	"TOP",			--> anchor point of the healtbar to the name text
		xoffset =	3, 				--> x-offset of the anchor 
		yoffset =	-2, 			--> y-offset of the anchor
	}
	
--> LEVEL text attributes
	cfg.level = {
		font = 		mediapath.."verdanab.ttf", 
		fontSize = 	6.5,
		fontFlag = 	"OUTLINE",
		alpha = 	0.9,
		anchor = 	"RIGHT", 		--> anchor point of the level text to the name text
		anchor2 =	"LEFT", 		--> anchor point of the healthbar to the level text
		xoffset =	-1, 			--> x-offset of the anchor 
		yoffset =	0, 				--> y-offset of the anchor
	}
		
--> HEALTH text attributes
	cfg.health = {
		font = 		mediapath.."verdanab.ttf", 
		fontSize = 	6,
		fontFlag = 	"THINOUTLINE", 
		color = 	{ 1, 1, 1 }, 
		alpha = 	1, 
		anchor = 	"CENTER", 		--> anchor point of the health text to the health bar 
		anchor2 = 	"CENTER", 		--> anchor point of the health bar to the health text
		xoffset =	0, 				--> x-offset of the anchor 
		yoffset =	0, 				--> y-offset of the anchor
	}
	
--HANDOVER for other lua files
ns.cfg = cfg

